import { Sequelize, DataTypes, Model, Optional } from "sequelize";

interface BoatTypeAttributes {
  id: string;
  name: string;
}
export interface BoatTypeInput extends Optional<BoatTypeAttributes, "id"> {}

class BoatType
  extends Model<BoatTypeAttributes, BoatTypeInput>
  implements BoatTypeAttributes
{
  declare id: string;
  declare name: string;

  declare readonly createdAt: Date;
  declare readonly updatedAt: Date;
}

export const initBoatType = async (sequelizeConnection: Sequelize) => {
  BoatType.init(
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
        allowNull: false,
      },
      name: {
        type: new DataTypes.STRING(),
        allowNull: false,
      },
    },
    {
      tableName: "boattype",
      sequelize: sequelizeConnection,
    }
  );
};
export default BoatType;
